#include "ros/ros.h"
#include "std_msgs/Float32.h"

/**
* This tutorial demonstrates simple receipt of messages over the ROS system.
*/
long double syncSignal;
long double syncSpeed;

int main(int argc, char **argv)
{
  ros::init(argc, argv, "syncTestNode");
  ros::NodeHandle n;
  ros::Publisher syncPub = n.advertise<std_msgs::Float32>("plath/sync_signal", 10);
  ros::Rate loop_rate(10);

  int count = 0;
  syncSignal = 0.0;
  syncSpeed = 0.002;

  while (ros::ok())
  {
    std_msgs::Float32 msg;
    msg.data = syncSignal;
    syncPub.publish(msg);

    ros::spinOnce();
    loop_rate.sleep();
    ++count;
    syncSignal = syncSignal + syncSpeed;
  }
  return 0;
}
